//----------------------------------------------------------------------------
//C main line  쐬@iLjؓdq
//Temp_Control     DATE 2009/05/02

//Selected Global Parameters: ȉ̒ʂݒBw薳Ұ́A̫ĒlƂ
//    CPU_Clock            12_MHz (SysClk/2) 
//    Ref Mux              (Vdd/2)+/-(Vdd/2) 
//    Supply Voltage       5.0V 
//    SysClk Source        Internal 24_MHz 
//    SysClk*2             Disable No 
//    VC1= SysClk/N        16 
//    VC2= VC1/N            9 
//    VC3 Divider          167 
//    VC3 Source           VC2 

//User Module Detail ADCINCVR 
//    ADCResolution        13 Bit 
//    CalcTime             566   (SampleRate = 166.67KHz/(2y15+566)=5s/sec)
//    Clock                VC2 
//    ClockPhase           Norm 
//    DataFormat           Signed 
//    Input                Port_2_1 

//User Module Detail RefMux
//    Reference Select     AGND

//User Module Detail LCD
//    BarGraph             Disable 
//    LCDPort              Port_1 

//User Module Detail PGA
//    AnalogBus            AnalogOutBus_2 (P04֏o)
//    Gain                 2.000 
//    Input                AnalogColumn_InputSelect_2 (P05)
//    Reference            AGND 

//User Module Detail PWM16
//    Clock                VC3 
//    ClockSync            Sync to SysClk 
//    CompareOut           Row_1_Output_3 (P27֏o)
//    CompareType          Less Than 
//    Enable               High 
//    InterruptType        Terminal Count 
//    InvertEnable         Normal 
//    Period               10000 
//    PulseWidth           5000 
//    TerminalCountOut     None 

//߰Đݒ͈ȉ̒ʂ
//    PRT0DR      P00:    P01:    P02:    P03:RefMux out(AGND)
//                P04:PGAout    P05:PGAinput    P06:   P07:
//    PRT1DR      P10-16:LCD output        P17:
//    PRT2DR      P21:ADCinput  P23:xݒSW1   P25:SW2  P20:SW3  P27:Ry output
//    iFP20,23,25́ADriveӰނHighZɐݒvj
//----------------------------------------------------------------------------

#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules

signed int        ADdata;      //ADϊʏWv
signed int        ADmeans[8];  //Ϗpe[u
signed int        Temp;        //x茋ʁi0.1Pʁj
signed int        SetTemp;     //ݒ艷xi0.1Pʁj
signed int        Duty;        //xᐧoDUtyiPPʁj
unsigned char     DipSW;       //DipSWݒliO`Vj

#define Temp70    725        //70ݒl
#define Temp60    620        //60ݒl
#define Temp55    570        //55ݒl
#define Temp50    515        //50ݒl
#define Temp40    410        //40ݒl
#define Temp23    230        //23ݒl
#define Temp10    100        //10ݒl
#define Temp00    000        // 0ݒl

#define    sw1    (PRT2DR & 0x08)    //SW1߰Ē`
#define    sw2    (PRT2DR & 0x20)    //SW2߰Ē`
#define    sw3    (PRT2DR & 0x01)    //SW3߰Ē`

void    signedItoC(char*, signed int);    //16bitHex to Decimal_char
char cDec[]=" 00000";                    //Decimal char Buffer

void main()
{
    unsigned char    p = 0;        //Ϗp߲
    unsigned char    i;
//start PGA
    PGA_Start(PGA_HIGHPOWER);
    RefMux_Start(RefMux_HIGHPOWER);
//start LCD
    LCD_Start();                  // Initialize LCD
//xݒE\
    DipSW = 0;
    if(!sw1)    DipSW += 1;
    if(!sw2)    DipSW += 2;
    if(!sw3)    DipSW += 4;
    switch(DipSW){
        case    0:    SetTemp = Temp00;    break;
        case    1:    SetTemp = Temp10;    break;
        case    2:    SetTemp = Temp23;    break;
        case    3:    SetTemp = Temp40;    break;
        case    4:    SetTemp = Temp50;    break;
        case    5:    SetTemp = Temp55;    break;
        case    6:    SetTemp = Temp60;    break;
        case    7:    SetTemp = Temp70;    break;
    }

    signedItoC(cDec, SetTemp);        //iHex -> Decimal char
    cDec[2] = cDec[3];
    cDec[3] = cDec[4];
    cDec[4] = '.';
    LCD_Position(0,7);
       LCD_PrString(cDec);
    
     // ensure interrupt is disabled
    PWM16_DisableInt();  
    //start the PWM16
    PWM16_Start();  

    M8C_EnableGInt;                     // Enable global interrupts  
    ADCINCVR_Start(ADCINCVR_HIGHPOWER);  // Turn on Analog section  
    ADCINCVR_GetSamples(0);             // Start ADC to read continuously  
    
    while(1){ 
        //AQADϊ
        ADdata = 0; 
        while(ADCINCVR_fIsDataAvailable() == 0); // Wait for data to be ready.  
        ADdata = ADCINCVR_iGetData() + ADdata;    // Get Data  
        ADCINCVR_ClearFlag();           // Clear data ready flag 
        
        while(ADCINCVR_fIsDataAvailable() == 0); // Wait for data to be ready.  
        ADdata = ADCINCVR_iGetData() + ADdata;    // Get Data  
        ADCINCVR_ClearFlag();           // Clear data ready flag

        //ω
           ADmeans[p] = ADdata >> 1;    //ZpE
           p++;
           if(p > 7)    p = 0;    //߲
           
           ADdata = 0;
           for(i=0; i<8; i++){
               ADdata = ADmeans[i] + ADdata;
           }
           ADdata = (ADdata >> 3);
           
           //LCD\
        signedItoC(cDec, ADdata);        //iHex -> Decimal char
        LCD_Position(0,0);
        LCD_PrString(cDec);

    //Temp PޯĂF(0.1deg~10mV~2{^5V)~2Y(13)=3.2768
        Temp = (float)ADdata / 3.2768; 
        signedItoC(cDec, Temp);        //iHex -> Decimal char
        cDec[2] = cDec[3];
        cDec[3] = cDec[4];
        cDec[4] = '.';
        LCD_Position(1,0);
        LCD_PrString(cDec);

       //vZJn
           //0.1Pʂ̐ݒlƎx̍̂Q{pXޭ-èɂ
        Duty = (SetTemp - Temp)*2;        //Duty = 0`100
        if(Duty < 0)    Duty = 0;
        switch(DipSW){
            case 0:    if(Duty>30)        Duty=30;    break;    //1.5
            case 1:    if(Duty>30)        Duty=30;    break;    //1.5
            case 2:    if(Duty>40)        Duty=40;    break;    //2
            case 3:    if(Duty>60)        Duty=60;    break;    //3
            case 4:    if(Duty>80)        Duty=80;    break;    //4
            case 5:    if(Duty>80)        Duty=80;    break;    //4
            case 6:    if(Duty>100)       Duty=100;   break;    //5
            case 7:    if(Duty>100)       Duty=100;   break;    //5
        }

       //DUty@LCD\
        signedItoC(cDec, Duty);        //iHex -> Decimal char
        cDec[0] = 'D';
        cDec[1] = 'y';
        cDec[2] = '%';
        LCD_Position(1,7);
        LCD_PrString(cDec);

        //PWM16o͏
        Duty = Duty * 100;            //0.1msecPʂɕϊ
       //set pulse width to output% duty cycle
        PWM16_WritePulseWidth((unsigned int)Duty );  
           
           ADCINCVR_ClearFlag();           // Clear data ready flag 
           
   } 
}

//16bitHex to Decimal_char
void    signedItoC(char* p, signed int iHexData)
{   signed int iHexData2;
    signed char i;
    
    iHexData2 = iHexData;
    if(iHexData < 0){
        iHexData2 = iHexData2 * -1;
    }
    for(i=5; i>0; i--){
        p[i] = (char)((iHexData2 % 10) + 0x30);
        iHexData2 = iHexData2 / 10;
    }
    p[0] = ' ';
    if(iHexData < 0)    p[0] = '-';
}
